<template>
  <q-card style="width: 90vw !important">
    <q-card-section>
      <div class="text-h6">Rozmowa z {{ props.selectedPerson?.nick }}</div>
    </q-card-section>

    <q-card-section class="q-pt-none">
      <ul
        ref="$ul"
        @scroll="handleScroll"
        @un-scrolled="
          () => {
            eventBus.emit('scrolled-to-top');
          }
        "
        style="overflow-y: scroll"
      >
        <li
          v-for="(talk, index) in messages"
          :key="index"
          :class="{ right: talk.nick === props.selectedPerson?.nick }"
        >
          <h6>
            {{ getNick(talk) }}
          </h6>

          <div v-html="talk.content"></div>
          <span>
            {{
              new Date(Date.parse(talk.datetime)).toLocaleDateString('pl-PL') +
              ', ' +
              new Date(talk.datetime).toLocaleTimeString('pl-PL', {
                weekday: 'long',
              })
            }}</span
          >
        </li>

        <li></li>
      </ul>
    </q-card-section>

    <q-card-actions align="right" class="text-primary">
      <InputComponent
        v-if="!props.selectedPerson?.blocked && !props.selectedPerson?.blocks"
        @content="setContent"
      />
      <q-btn
        v-if="!props.selectedPerson?.blocked && !props.selectedPerson?.blocks"
        flat
        dense
        round
        icon="send"
        aria-label="Menu"
        @click="sendMessage"
      />
    </q-card-actions>
    <div v-if="props.selectedPerson?.blocks" class="blocks-warning">
      Użytkownik {{ props.selectedPerson?.nick }} Cię zablokował
    </div>
    <div v-if="props.selectedPerson?.blocked" class="blocks-warning">
      Zablokował{{ user.sex ? 'eś' : 'aś' }} użytkownika
      {{ props.selectedPerson?.nick }}
    </div>
  </q-card>
</template>
<script setup lang="ts">
import { onMounted, ref, watch } from 'vue';
import { useUserStore } from '../stores/user';
import { useSocketStore } from '../stores/socket';

import eventBus from '../eventBus';
import { api } from '../boot/axios';

import Person from '../interfaces/Person';
import Message from '../interfaces/Message';

import InputComponent from './InputComponent.vue';

defineOptions({ name: 'TalksComponent' });
export interface TalksComponentProps {
  selectedPerson: Person | null | undefined;
}

const props = withDefaults(defineProps<TalksComponentProps>(), {});

const userStore = useUserStore();
const { user } = userStore;

const socketStore = useSocketStore();
const { ws } = socketStore;
const messages = ref<Message[]>([]);

const content = ref<string>('');
const $ul = ref<HTMLUListElement | null>(null);
onMounted(() => {
  setFriend();
  eventBus.on('scroll-to-bottom', () => {
    if ($ul.value) $ul.value.scrollTop = $ul.value.scrollHeight;
  });

  if (props.selectedPerson)
    eventBus.on(props.selectedPerson.nick, (data) => {
      console.log(data);
      if (!props.selectedPerson) return;
      const message: Message = {
        content: data.content,
        datetime: data.datetime,
        nick: props.selectedPerson.nick,
      };
      messages.value.push(message);
    });
  setFriend();
});

function setFriend() {
  api
    .get('/user/messages', {
      params: {
        uuid: user.uuid,
        friendNick: props.selectedPerson?.nick,
      },
    })
    .then(({ data }) => {
      messages.value = data.sort(
        (a: { datetime: string }, b: { datetime: string }) => {
          return (
            new Date(a.datetime).getTime() - new Date(b.datetime).getTime()
          );
        }
      );
      setTimeout(() => {
        if ($ul.value) $ul.value.scrollTop = $ul.value.scrollHeight;
      }, 0);

      //   this.talks = data;
      //   this.$nextTick(()=>{
      // this.scrollToBottom();
    });
}

function setContent(contentInInput: string) {
  console.log(content);
  content.value = contentInInput;
}

function sendMessage() {
  if (!props.selectedPerson || !ws) {
    return;
  }
  const message = {
    datetime: new Date().toISOString().slice(0, 19).replace('T', ' '),
    nick: user.nick,
    content: content.value,
  };
  messages.value.push(message);
  content.value = '';
  ws.send(
    JSON.stringify({
      message: {
        [props.selectedPerson?.nick]: JSON.stringify(message),
        from: user.uuid,
      },
    })
  );
  setContent('');
  eventBus.emit('clear-input');
}

function handleScroll() {
  const el = $ul.value;
  if (!el) return;
  // Sprawdzenie czy scrollTop + clientHeight >= scrollHeight
  if (el.scrollTop + el.clientHeight >= el.scrollHeight) {
    eventBus.emit('scrolled-to-bottom');
  } else {
    eventBus.emit('scrolled-to-top');
  }
}

function getNick(talk: { nick?: string }) {
  if (typeof talk.nick === 'undefined') {
    return user.nick;
  }
  return talk.nick === props.selectedPerson?.nick
    ? user.nick
    : props.selectedPerson?.nick;
}

// function getNick(talk: {
//   content: string;
//   datetime: string;
//   nick?: string | undefined;
// }) {
//   if (typeof talk.nick === 'undefined') {
//     return user.nick;
//   }
//   if (!props.selectedPerson) return;
//   return talk.nick === props.selectedPerson.nick
//     ? user.nick
//     : props.selectedPerson.nick;
// }

watch(
  () => props.selectedPerson,
  (newPerson, oldPerson) => {
    if (newPerson?.nick !== oldPerson?.nick) {
      // Resetuj wiadomości i pobierz nowe wiadomości dla wybranego użytkownika
      messages.value = [];
      setFriend();

      // Zaktualizuj nasłuchiwanie wiadomości dla nowej osoby
      // if (newPerson) {
      //   eventBus.on(newPerson.nick, (data) => {
      //     const message: Message = {
      //       content: data.content,
      //       datetime: data.datetime,
      //       nick: newPerson.nick,
      //     };
      //     messages.value.push(message);
      //   });
      // }
    }
  },
  { deep: true }
);
</script>
<style scoped lang="scss">
.blocks-warning {
  color: #111111;
  right: -1px;
  position: relative;
  justify-content: center;
  display: flex;
  height: 100px;
  line-height: 100px;
  outline: 1px solid #111111;
}
li {
  list-style-type: none;
  &.right {
    position: relative;
    left: 100px;
  }
}
h6 {
  font-size: 14px;

  margin-top: 0px;
  margin-bottom: 0px;
}
</style>
